require 'display_triangle.rb'
require 'pattern_plotter.rb'
require 'gerber_reader.rb'


# --------------------------------------------------

graphic = MYGLWindowViewTriangle.new(800, 600, "preview")
canvas = PatternPlotter.new
canvas.set_round_resolution(12)
canvas.marge_outline = true

gerber = GFileReader.new
gerber.load('test_sol.gbr')

max = gerber.get.size
count = 0
gerber.get.each do |item|
  count += 1
  printf("%d/%d\n", count, max)
  canvas.set_mil_size(0.24)
  canvas.set_pad_round(item['is_round'])
  canvas.set_pad_size(item['width'])
  p1 = PPoint.new(item['start_x'], item['start_y'], 0)
  p2 = PPoint.new(item['end_x'], item['end_y'], 0)
  if (p1.x == p2.x) && (p1.y == p2.y) then
    canvas.flash(p1.x, p1.y)
  else
    canvas.move(p1.x, p1.y, p2.x, p2.y)
  end
end

canvas.get_object.each do |tri|
  graphic.add_object(tri)
end
canvas.get_outline.each do |line|
  graphic.add_line(line)
end

open("mil_seq.txt", "w") do |fp|
  canvas.get_outline.each do |line|
    printf(fp, "%f %f %f %f\n", line[0].x, line[0].y, line[1].x, line[1].y)
  end
end

graphic.running
